'This program reads a file containing information for a five-day weather
'forecast, uses the information to initialize an array of objects
'an array of usercontrols are used to diaply the information
'the user can elect to see some statistics on the weather forecast


'it was a lab 

Imports System.IO


Public Class FrmWeather

    Dim MyWeatherDay As ClsWeatherDay()     'array of weather objects
    Dim MyucWeatherday As ucWeatherDay()    'array of usercontrols
    Dim MyLocation As String                'location ot exe, where data file and images are


    '******************************************************
    'read the file, 
    'instantiate and initialize the weather objects
    'instantiate and initialize the usercontrols
    Private Sub FrmWeather_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim MyStreamReader As StreamReader
        Dim myfile As String
        Dim Myline As String()
        Dim MyToken As String()
        Dim i As Integer

        MyLocation = Directory.GetCurrentDirectory

        Try
            MyStreamReader = New StreamReader(MyLocation & "\Forecast.txt")
            myfile = MyStreamReader.ReadToEnd
            MyStreamReader.Close()
        Catch ex As Exception
            MsgBox("Problem reading file.")
            Exit Sub
        End Try

        'parse file contents on return character
        Myline = myfile.Split(vbCrLf)

        'instantiate array of weather objects and usercontrols
        MyWeatherDay = New ClsWeatherDay(Myline.Length - 1) {}
        MyucWeatherday = New ucWeatherDay(Myline.Length - 1) {}


        For i = 0 To Myline.Length - 1
            Myline(i) = Myline(i).Trim
            MyToken = Myline(i).Split(",")

            'instantiate element of weather array
            MyWeatherDay(i) = New ClsWeatherDay

            MyWeatherDay(i).Day = MyToken(0).Trim
            MyWeatherDay(i).Description = MyToken(1).Trim
            MyWeatherDay(i).HighTempF = MyToken(2).Trim
            MyWeatherDay(i).LowTempF = MyToken(3).Trim

            'instantiate individual usercontrol
            MyucWeatherday(i) = New ucWeatherDay

            panForecast.Controls.Add(MyucWeatherday(i))
            MyucWeatherday(i).Location = New Point(MyucWeatherday(0).Width * i, 0)
            MyucWeatherday(i).lblday.Text = MyWeatherDay(i).Day

            'uses String method Replace to eliminate spaces in  
            'description to construct corresponding image file names
            MyucWeatherday(i).picWeather.Image = Image.FromFile(MyLocation & "\" & MyWeatherDay(i).Description.Replace(" ", "") & ".gif")

            'uses Chr(176) to get degree symbol
            'recall we looked up the number in the Character Map (All Programs/Accessories)
            MyucWeatherday(i).lblDesc.Text = MyWeatherDay(i).Description
            MyucWeatherday(i).lblTemp.Text = MyWeatherDay(i).HighTempF & Chr(176) & vbCrLf & MyWeatherDay(i).LowTempF & Chr(176)
        Next

    End Sub

    '*******************************************************
    'change to Celsius temperature display
    Private Sub radCel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radCel.Click
        Dim i As Integer

        For i = 0 To MyWeatherDay.Length - 1
            MyucWeatherday(i).lblTemp.Text = MyWeatherDay(i).HighTempC & Chr(176) & vbCrLf & MyWeatherDay(i).LowTempC & Chr(176)
        Next
    End Sub

    '*******************************************************
    'change (back) to Fahrenheit temperature display
    Private Sub radFar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles radFar.Click
        Dim i As Integer

        For i = 0 To MyWeatherDay.Length - 1
            MyucWeatherday(i).lblTemp.Text = MyWeatherDay(i).HighTempF & Chr(176) & vbCrLf & MyWeatherDay(i).LowTempF & Chr(176)
        Next
    End Sub

    '*****************************************************
    'calculate statistics
    'we only did the highest high temperature for Farenheit
    Private Sub btnStat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStat.Click
        Dim i As Integer
        Dim HighTemp As Integer
        Dim LowTemp As Integer
        Dim HighIndex As Integer
        Dim LowIndex As Integer

        lblStats.Text = ""
        If radFar.Checked Then
            'Farenheit

            'Highest High
            HighTemp = MyWeatherDay(0).HighTempF
            HighIndex = 0
            LowTemp = MyWeatherDay(0).LowTempF
            LowIndex = 0
            For i = 1 To MyWeatherDay.Length - 1
                If MyWeatherDay(i).HighTempF > HighTemp Then
                    HighTemp = MyWeatherDay(i).HighTempF
                    HighIndex = i
                End If

            Next
            lblStats.Text &= "Highest high: " & HighTemp & Chr(176) & " (" & MyWeatherDay(HighIndex).Day & ")" & vbCrLf

        Else
            'Celsius

        End If
    End Sub
End Class
